//Vorgehen:
//Kraft, die von B auf A wirkt.
//von A auf B: einfach Vorzeichen umdrehen!

//1. Berechnung der Wirkrichtung aus Verbindungslinie zwischen den Schwerpunkten.
//2. Überdeckungsgrad der Farbflächen bestimmen.

//Zunächst vereinfacht: Radius kleiner Schwelle

public void setzeKollisionskraft()
{
    double[] eK = new double[2]; //Richtungsvektor
    double[] FK = new double[2]; //Richtungsvektor
  
    
  
    eK[0] = yA_alt[0] - yB_alt[0];
    eK[1] = yA_alt[1] - yB_alt[1];
    
    double laenge = Math.sqrt(eK[0]*eK[0]+eK[1]*eK[1]);
  
    if(laenge<0.0001)
        laenge = 0.0001;
  
    eK[0]/=laenge;
    eK[1]/=laenge;
    
    FK[0]=0.0;
    FK[1]=0.0;
    
    double SUMORADIUS = 0.2; 
    
    if(laenge<SUMORADIUS)
    {
        FK[0] = 10000.0*eK[0]*(SUMORADIUS-laenge);
        FK[1] = 10000.0*eK[1]*(SUMORADIUS-laenge);
        
        sumoA.Fkollisionx = FK[0];
        sumoA.Fkollisiony = FK[1];
        sumoB.Fkollisionx = -FK[0];
        sumoB.Fkollisiony = -FK[1];
        
        //Wirkpunkt der Kollisionskraft bestimmen:
        double[] wirk = new double[2];
        
        wirk[0] = yB_alt[0] + laenge*0.5*eK[0]; 
        wirk[1] = yB_alt[1] + laenge*0.5*eK[1];
        
        //Mit Kreuzprodukt für beide Sumos berechnen:
        
        sumoA.Mkollision = (wirk[0]-yA_alt[0])*FK[1] - (wirk[1]-yA_alt[1])*FK[0]; 
        sumoB.Mkollision = (wirk[0]-yB_alt[0])*(-FK[1]) - (wirk[1]-yB_alt[1])*(-FK[0]); 
    }
    else
    {
  
        sumoA.Fkollisionx = 0.0;
        sumoA.Fkollisiony = 0.0;
        sumoA.Mkollision  = 0.0;
        sumoB.Fkollisionx = 0.0;
        sumoB.Fkollisiony = 0.0;
        sumoB.Mkollision  = 0.0;
    }
    
}
