public class Sumo implements Modell
{
//Punkte:
   int ANZ=0;

    public double[] PS={0,0};

    public double[] PA={ 0.0565  ,  -0.054};
    public double[] PB={ 0.0565  ,   0.054};
    public double[] PC={-0.0565  ,   0.054};
    public double[] PD={-0.0565  ,  -0.054};

    public double[] PE={ 0.1065  , -0.085};
    public double[] PF={ 0.1065  ,  0.085};
    public double[] PG={-0.1325  ,  0.085};
    public double[] PH={-0.1325  , -0.085};

     //Masse des Fahrzeugs:
    public double m = 0.871; //kg

    //Masseträgheitsmoment:
    //Korpus als homogen angenommen,
    //Stoßstange als masselos:

    public double J = (1.0/12.0)*m*(0.108*0.108 + 0.113*0.113); //kg*m/s**2

    //Verstärkungsfaktor, mit dem die pwm-Werte multipliziert werden,
    //um die Antriebskraft zu erhalten:
//    public double PWMFAKTOR = 0.0083777; //gesuchter Parameter. Dies ist der Startwert.

    //Linearfaktor für den Dämpfungsterm in jedem Punkt A,B,C,D:
//    public double DAMP      = 20.322368; //gesuchter Parameter. Dies ist der Startwert.

//NEU NEU NEU:
//   PWMFAKTOR = 0.0245147 
//   DAMP      = 29.469469 (statt 22.175475)
//   Fehler    = 0.0690086 (statt 0.2459775)

    public double PWMFAKTOR = 0.0245147; //gesuchter Parameter. Dies ist der Startwert.
    public double DAMP      = 29.469469; //gesuchter Parameter. Dies ist der Startwert.
  
  
    public double x,y,phi,vx,vy,om;
    public double Fkollisionx = 0;
    public double Fkollisiony = 0;
    public double Mkollision  = 0;

//    public double PWM_L = 799.0;
//    public double PWM_R = 799.0;
    public double PWM_L = 0.0;
    public double PWM_R = 0.0;
    
    public double pwm_links;
    public double pwm_rechts;
    public double Fantrieb_links;
    public double Fantrieb_rechts;
  
    public double[] FanL = new double[2];
    public double[] FanR = new double[2];
    
  
    public Sumo()
    {
    }
  
    public int getGleichungsanzahl()
    {
         return 6;
    }
    public void steigung(double[] f, double[] yy,double t)
    {
        x   = yy[0];
        y   = yy[1];
        phi = yy[2];

        vx   = yy[3];
        vy   = yy[4];
        om   = yy[5];
        //Kollisionskräfte sind zunächst keine vorhanden:
        
        /*
        Fkollisionx = 0.0;
        Fkollisiony = 0.0;
        Mkollision  = 0.0;
        */
    
        //Die linke und rechte Antriebskraft wird aus den PWM-Signalen
        //mit einem Verstärkungsfaktor gebildet:
        //    pwm_links  = 799;
        pwm_links  = PWM_L;
        pwm_rechts = PWM_R;
        Fantrieb_links  = pwm_links  * PWMFAKTOR;
        Fantrieb_rechts = pwm_rechts * PWMFAKTOR;

        //Die Antriebskräfte wirken in die Richtung, in die das Fahrzeug gerade orientiert ist:
        FanL = dr(new double[] {Fantrieb_links,0.0},  phi);
        FanR = dr(new double[] {Fantrieb_rechts,0.0}, phi);




        //Vorbereitung der Dämpfungskräfte:
        //a) Verbindungsvektoren von S zu ABCD im Inertialkoordinatensystem
        double[] rA = dr(PA,  phi);
        double[] rB = dr(PB,  phi);
        double[] rC = dr(PC,  phi);
        double[] rD = dr(PD,  phi);
        //b) Aktuelle Geschwindigkeit in jedem Punkt ABCD bestimmen:
        //   vp = v + w x r
        double[] vA = summe(new double[] {vx,vy},kv(om,rA)); 
        double[] vB = summe(new double[] {vx,vy},kv(om,rB)); 
        double[] vC = summe(new double[] {vx,vy},kv(om,rC)); 
        double[] vD = summe(new double[] {vx,vy},kv(om,rD)); 
        //c) Dämpfungskräfte entgegen aktueller Geschw. im jeweiligen Punkt:
        double[] FDampA = skalmult(-DAMP,vA);
        double[] FDampB = skalmult(-DAMP,vB);
        double[] FDampC = skalmult(-DAMP,vC);
        double[] FDampD = skalmult(-DAMP,vD);


        //Reibkraft vorbereiten:
        //6N insgesamt, 1.5 pro Kraftangriffspunkt.
        //a) Skalare der Geschwindigkeitsanteile vorwärts und zur Seite bestimmen
        double[] evorn = dr(new double[] {1,0},  phi);
        double[] eseit = dr(new double[] {0,1},  phi);
        double vAvorn = skalarprodukt(vA,evorn);
        double vAseit = skalarprodukt(vA,eseit);
        double vBvorn = skalarprodukt(vB,evorn);
        double vBseit = skalarprodukt(vB,eseit);
        double vCvorn = skalarprodukt(vC,evorn);
        double vCseit = skalarprodukt(vC,eseit);
        double vDvorn = skalarprodukt(vD,evorn);
        double vDseit = skalarprodukt(vD,eseit);

    //Neu: Reibkraft wirkt gegen Bewegung, wenn diese eine gewisse Schwelle überschritten hat:
        double[] FReibA = new double[] {0.0,0.0};    
        double[] FReibB = new double[] {0.0,0.0};    
        double[] FReibC = new double[] {0.0,0.0};    
        double[] FReibD = new double[] {0.0,0.0};    

//Reibkraft weglassen, dafür Dämpfung und Antrieb höher, nach letzter Identifikation
/*
     double SCHWELLE = 0.001;
     if(betrag(vA)>=SCHWELLE)
     {
           //Einheitsvektor in die Richtung bilden und negieren:
           double[] eA = negricht(vA);
           FReibA[0] = 1.5*eA[0];  // 1/4 der 6 Newton
           FReibA[1] = 1.5*eA[1];  // 1/4 der 6 Newton
     }
     if(betrag(vB)>=SCHWELLE)
     {
           //Einheitsvektor in die Richtung bilden und negieren:
           double[] eB = negricht(vB);
           FReibB[0] = 1.5*eB[0];  // 1/4 der 6 Newton
           FReibB[1] = 1.5*eB[1];  // 1/4 der 6 Newton
     }
     if(betrag(vC)>=SCHWELLE)
     {
           //Einheitsvektor in die Richtung bilden und negieren:
           double[] eC = negricht(vC);
           FReibC[0] = 1.5*eC[0];  // 1/4 der 6 Newton
           FReibC[1] = 1.5*eC[1];  // 1/4 der 6 Newton
     }
     if(betrag(vD)>=SCHWELLE)
     {
           //Einheitsvektor in die Richtung bilden und negieren:
           double[] eD = negricht(vD);
           FReibD[0] = 1.5*eD[0];  // 1/4 der 6 Newton
           FReibD[1] = 1.5*eD[1];  // 1/4 der 6 Newton
     }
*/     
    //Die Kräfte setzen sich aus den einzelnen Komponenten zusammen:
    
    double[] FA = summe(skalmult(0.5,FanR),FDampA,FReibA);
    double[] FB = summe(skalmult(0.5,FanL),FDampB,FReibB);
    double[] FC = summe(skalmult(0.5,FanL),FDampC,FReibC);
    double[] FD = summe(skalmult(0.5,FanR),FDampD,FReibD);

    //Momente, die durch die Kräfte in ABCD wirken bestimmen:
    double MA = kr(rA,FA);
    double MB = kr(rB,FB);
    double MC = kr(rC,FC);
    double MD = kr(rD,FD);


    //Aufspaltung der Kräfte in x/y-Komponenten:
    double FAx = FA[0];
    double FAy = FA[1];
    double FBx = FB[0];
    double FBy = FB[1];
    double FCx = FC[0];
    double FCy = FC[1];
    double FDx = FD[0];
    double FDy = FD[1];

    f[0] = vx;
    f[1] = vy;
    f[2] = om;

    f[3] = (FAx+FBx+FCx+FDx  + Fkollisionx)/m;
    f[4] = (FAy+FBy+FCy+FDy  + Fkollisiony)/m;
    f[5] = (MA +MB +MC +MD   + Mkollision)/J;
        
    }
     
}
